unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, scControls, scModernControls,
  Vcl.StdCtrls, scExtControls, scStyledForm, scStyleManager,
  Vcl.ExtCtrls, scImageCollection, ShellApi, Vcl.Mask,
  scAdvancedControls, scHint, scDrawUtils, scGPImages,
  scGPControls, scGPExtControls, Vcl.Menus, scGPFontControls, scGPPagers, Vcl.Themes,
  System.Skia, Vcl.Skia;

type
  TForm1 = class(TForm)
    scStyleManager1: TscStyleManager;
    scStyledForm1: TscStyledForm;
    BorderPanel: TscGPPanel;
    ClientPanel: TscPanel;
    scGPPanel2: TscGPPanel;
    CloseButton: TscGPGlyphButton;
    MinButton: TscGPGlyphButton;
    CaptionLabel: TscLabel;
    MaxButton: TscGPGlyphButton;
    scGPPanel3: TscGPPanel;
    scGPSizeBox1: TscGPSizeBox;
    PopupMenu1: TPopupMenu;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    Print1: TMenuItem;
    PrintSetup1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    scPageViewer1: TscPageViewer;
    scPageViewerPage1: TscPageViewerPage;
    scPageViewerPage2: TscPageViewerPage;
    scPageViewerPage4: TscPageViewerPage;
    scLabel28: TscLabel;
    scLabel13: TscLabel;
    scButton10: TscButton;
    scLabel14: TscLabel;
    scPageViewerPage3: TscPageViewerPage;
    scButton1: TscButton;
    scButton2: TscButton;
    scLabel1: TscLabel;
    scLabel2: TscLabel;
    scGPPanel1: TscGPPanel;
    scGPPanel15: TscGPPanel;
    scGPImageCollection1: TscGPImageCollection;
    scCheckBox2: TscCheckBox;
    scCheckBox4: TscCheckBox;
    scGPToggleSwitch1: TscGPToggleSwitch;
    scLabel4: TscLabel;
    scAdvancedComboBox1: TscAdvancedComboBox;
    MenuButton: TscGPGlyphContainerButton;
    MenuAnimatedImage: TSkAnimatedImage;
    scGPGlyphContainerButton1: TscGPGlyphContainerButton;
    SkAnimatedImage1: TSkAnimatedImage;
    scGPGlyphContainerButton2: TscGPGlyphContainerButton;
    SkAnimatedImage2: TSkAnimatedImage;
    scGPGlyphContainerButton3: TscGPGlyphContainerButton;
    SkAnimatedImage3: TSkAnimatedImage;
    scGPGlyphContainerButton4: TscGPGlyphContainerButton;
    SkAnimatedImage4: TSkAnimatedImage;
    ExitButton: TscGPGlyphContainerButton;
    SkAnimatedImage5: TSkAnimatedImage;
    procedure scStyledForm1ChangeScale(AScaleFactor: Double);
    procedure CloseButtonClick(Sender: TObject);
    procedure MinButtonClick(Sender: TObject);
    procedure MaxButtonClick(Sender: TObject);
    procedure CaptionLabelDblClick(Sender: TObject);
    procedure scStyledForm1ChangeActive(Sender: TObject);
    procedure CaptionLabelMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CaptionLabelMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CaptionLabelMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure scStyledForm1BeforeChangeScale(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure scButton10Click(Sender: TObject);
    procedure scStyledForm1DWMClientMaximize(Sender: TObject);
    procedure scStyledForm1DWMClientRestore(Sender: TObject);
    procedure ExitButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure scButton1Click(Sender: TObject);
    procedure scButton2Click(Sender: TObject);
    procedure scGPCharGlyphButton4Click(Sender: TObject);
    procedure scCheckBox2Click(Sender: TObject);
    procedure scCheckBox4Click(Sender: TObject);
    procedure scGPToggleSwitch1ChangeState(Sender: TObject);
    procedure scStyledForm1ChangeFluentUIBackground(Sender: TObject);
    procedure scAdvancedComboBox1Change(Sender: TObject);
    procedure MenuButtonMouseEnter(Sender: TObject);
    procedure MenuButtonMouseLeave(Sender: TObject);
    procedure scGPGlyphContainerButton3Click(Sender: TObject);
    procedure scGPGlyphContainerButton2Click(Sender: TObject);
    procedure scGPGlyphContainerButton4Click(Sender: TObject);
    procedure scGPGlyphContainerButton1Click(Sender: TObject);
    procedure scGPGlyphContainerButton3MouseEnter(Sender: TObject);
    procedure scGPGlyphContainerButton3MouseLeave(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Unit2, MessageUnit;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  if not scStyledForm1.IsFluentUIAvailable or (scStyledForm1.FluentUIBackground = scfuibNone) then
  begin
    StyleElements := [seClient];
    BorderPanel.FrameWidth := 1;
    SC_SetDrawTextModeInControl(scGPPanel1, scdtmGDI);
    scGPPanel1.FillColorAlpha := 200;
    scGPPanel1.TransparentBackground := False;
    scAdvancedComboBox1.Enabled := False;
    BorderPanel.FillColor := clBtnFace;
    ClientPanel.FluentUIOpaque := False;
  end
  else
  begin
    if IsWindows11 then
      BorderPanel.FrameWidth := 1;
  end;

  if IsWindows11 then
   scGPToggleSwitch1.State := scswOn;
end;

procedure TForm1.CaptionLabelMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbLeft) and not (ssDouble in Shift) and scStyledForm1.IsDWMClientMaximized then
   scStyledForm1.DWMClientStartDrag;
end;

procedure TForm1.CaptionLabelMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if scStyledForm1.IsDWMClientMaximized and scStyledForm1.IsDWMClientDragging then
  begin
    scStyledForm1.DWMClientDrag;
    if not scStyledForm1.IsDWMClientMaximized then
    begin
      MaxButton.GlyphOptions.Kind := scgpbgkMaximize;
      scGPSizeBox1.Visible := True;
    end;
  end;
end;

procedure TForm1.CaptionLabelMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  scStyledForm1.DWMClientEndDrag;
end;

procedure TForm1.CloseButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.MaxButtonClick(Sender: TObject);
begin
  if scStyledForm1.IsDWMClientMaximized then
    scStyledForm1.DWMClientRestore
  else
    scStyledForm1.DWMClientMaximize;
end;

procedure TForm1.MenuButtonMouseEnter(Sender: TObject);
begin
  MenuAnimatedImage.Animation.Enabled := True;
end;

procedure TForm1.MenuButtonMouseLeave(Sender: TObject);
begin
  MenuAnimatedImage.Animation.Enabled := False;
end;

procedure TForm1.MinButtonClick(Sender: TObject);
begin
  Application.Minimize;
end;

procedure TForm1.scAdvancedComboBox1Change(Sender: TObject);
begin
  if not scStyledForm1.IsFluentUIAvailable then
    Exit;

  scStyledForm1.FluentUIBackground := TscFluentUIBackground(scAdvancedComboBox1.ItemIndex);

  if scStyledForm1.IsFluentUIEnabled then
  begin
    BorderPanel.FillColor := clBlack;
    if not IsWindows11 then
       BorderPanel.FrameWidth := 0;
     ClientPanel.FluentUIOpaque := True;
     SC_SetDrawTextModeInControl(scGPPanel1, scdtmGDIPlus);
     scGPPanel1.TransparentBackground := True;
  end
  else
  begin
    BorderPanel.FrameWidth := 1;
    BorderPanel.FillColor := clBtnFace;
    ClientPanel.FluentUIOpaque := False;
    SC_SetDrawTextModeInControl(scGPPanel1, scdtmGDI);
    scGPPanel1.TransparentBackground := False;
    Color := scDrawUtils.GetStyleColor(clBtnFace);
  end;
end;

procedure TForm1.scButton10Click(Sender: TObject);
begin
  ShellExecute(0, 'open', 'http://www.almdev.com', nil, nil, SW_SHOWNORMAL);
end;

procedure TForm1.scButton1Click(Sender: TObject);
begin
  if not Assigned(Form2) then
    Form2 := TForm2.Create(Application);
  Form2.ShowModal;
end;

procedure TForm1.scButton2Click(Sender: TObject);
begin
  UWPInfoMessage('UWP Message Form', 'UWP message text');
end;

procedure TForm1.scCheckBox2Click(Sender: TObject);
begin
  if scCheckBox2.Checked then
    scGPPanel1.CustomImageIndex := 0
  else
    scGPPanel1.CustomImageIndex := -1;
end;

procedure TForm1.scCheckBox4Click(Sender: TObject);
begin
  MenuButton.FluentLightEffect := scCheckBox4.Checked;
  ExitButton.FluentLightEffect := scCheckBox4.Checked;
  scGPGlyphContainerButton1.FluentLightEffect := scCheckBox4.Checked;
  scGPGlyphContainerButton2.FluentLightEffect := scCheckBox4.Checked;
  scGPGlyphContainerButton3.FluentLightEffect := scCheckBox4.Checked;
  scGPGlyphContainerButton4.FluentLightEffect := scCheckBox4.Checked;
end;

procedure TForm1.ExitButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.scGPCharGlyphButton4Click(Sender: TObject);
begin
  scPageViewer1.PageIndex := TControl(Sender).Tag;
  scGPPanel15.Caption := TscGPCharGlyphButton(Sender).Caption;
end;

procedure TForm1.scGPGlyphContainerButton1Click(Sender: TObject);
begin
  scPageViewer1.PageIndex := TControl(Sender).Tag;
  scGPPanel15.Caption := TscGPCharGlyphButton(Sender).Caption;
end;

procedure TForm1.scGPGlyphContainerButton2Click(Sender: TObject);
begin
  scPageViewer1.PageIndex := TControl(Sender).Tag;
  scGPPanel15.Caption := TscGPCharGlyphButton(Sender).Caption;
end;

procedure TForm1.scGPGlyphContainerButton3Click(Sender: TObject);
begin
  scPageViewer1.PageIndex := TControl(Sender).Tag;
  scGPPanel15.Caption := TscGPCharGlyphButton(Sender).Caption;
end;

procedure TForm1.scGPGlyphContainerButton3MouseEnter(Sender: TObject);
begin
  TskAnimatedImage(TscGPGlyphContainerButton(Sender).GlyphContainer).Animation.Enabled := True;
end;

procedure TForm1.scGPGlyphContainerButton3MouseLeave(Sender: TObject);
begin
  TskAnimatedImage(TscGPGlyphContainerButton(Sender).GlyphContainer).Animation.Enabled := False;
end;

procedure TForm1.scGPGlyphContainerButton4Click(Sender: TObject);
begin
  scPageViewer1.PageIndex := TControl(Sender).Tag;
  scGPPanel15.Caption := TscGPCharGlyphButton(Sender).Caption;
end;

procedure TForm1.scGPToggleSwitch1ChangeState(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to scGPPanel1.ControlCount - 1 do
    if (scGPPanel1.Controls[I] is TscGPGlyphContainerButton) then
       if scGPPanel1.Controls[I].Tag >= 0 then
       with TscGPGlyphContainerButton(scGPPanel1.Controls[I]) do
       begin
         if scGPToggleSwitch1.IsOn then
         begin
           Options.ShapeStyle := scgpLeftRoundedLine;
           AlignWithMargins := True;
         end
         else
         begin
           if Tag > 0 then
             AlignWithMargins := False;
           Options.ShapeStyle := scgpLeftLine;
         end;
       end;

  if scGPToggleSwitch1.IsOn then
  begin
    scGPGlyphContainerButton3.Margins.Left := scGPGlyphContainerButton2.Margins.Left;
    scGPGlyphContainerButton3.Margins.Right := scGPGlyphContainerButton2.Margins.Right;
    MenuButton.Options.ShapeStyle := scgpTabBottom;
    ExitButton.Options.ShapeStyle := scgpRoundedRect;
    ExitButton.AlignWithMargins := True;
    scStyledForm1.DWMClientRoundedCornersType := scDWMRoundedCornersDefault;
  end
  else
  begin
    scGPGlyphContainerButton3.Margins.Left := 0;
    scGPGlyphContainerButton3.Margins.Right := 0;
    MenuButton.Options.ShapeStyle := scgpRect;
    ExitButton.Options.ShapeStyle := scgpRect;
    ExitButton.AlignWithMargins := False;
    scStyledForm1.DWMClientRoundedCornersType := scDWMRoundedCornersOff;
  end;

end;

procedure TForm1.CaptionLabelDblClick(Sender: TObject);
begin
  if scStyledForm1.IsDWMClientMaximized then
    scStyledForm1.DWMClientRestore
  else
    scStyledForm1.DWMClientMaximize;
end;

procedure TForm1.scStyledForm1BeforeChangeScale(Sender: TObject);
begin
  // avoid Delphi bug with Constrains when DPI chnaged
  Form1.Constraints.MinWidth := 0;
  Form1.Constraints.MinHeight := 0;
end;

procedure TForm1.scStyledForm1ChangeActive(Sender: TObject);
begin
  if Active then
  begin
    CaptionLabel.Font.Color := clBtnText;
    CloseButton.GlyphOptions.NormalColorAlpha := 255;
    MinButton.GlyphOptions.NormalColorAlpha := 190;
    MaxButton.GlyphOptions.NormalColorAlpha := 190;
  end
  else
  begin
    CaptionLabel.Font.Color := clGray;
    CloseButton.GlyphOptions.NormalColorAlpha := 150;
    MinButton.GlyphOptions.NormalColorAlpha := 120;
    MaxButton.GlyphOptions.NormalColorAlpha := 120;
  end;
end;

procedure TForm1.scStyledForm1ChangeFluentUIBackground(Sender: TObject);
begin
  if scStyledForm1.IsFluentUIEnabled then
  begin
    if scStyledForm1.IsFluentUIAcrylicBackground then
      scGPPanel1.FillColorAlpha := 100
    else
      scGPPanel1.FillColorAlpha := 230;
  end
  else
    scGPPanel1.FillColorAlpha := 200;
end;

procedure TForm1.scStyledForm1ChangeScale(AScaleFactor: Double);
begin
  Form1.Constraints.MinWidth := scStyledForm1.ScaleInt(700);
  Form1.Constraints.MinHeight := scStyledForm1.ScaleInt(400);
end;

procedure TForm1.scStyledForm1DWMClientMaximize(Sender: TObject);
begin
  BorderPanel.FrameColor := clBlack;
  MaxButton.GlyphOptions.Kind := scgpbgkRestore;
  scGPSizeBox1.Visible := False;
  BorderPanel.Sizeable := False;
end;

procedure TForm1.scStyledForm1DWMClientRestore(Sender: TObject);
begin
  BorderPanel.FrameColor := clHighLight;
  MaxButton.GlyphOptions.Kind := scgpbgkMaximize;
  scGPSizeBox1.Visible := True;
  BorderPanel.Sizeable := True;
end;

end.
